import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class BallCanvas extends ScaleCanvas implements KeyListener,MouseListener, MouseMotionListener {
    Manager M;
    ListenSquare CONTROL,SEND0;
    NumberEntry[] NUM=new NumberEntry[4];
    EnhancedSlider PITCH,YAW;
    Lever SPEED,COORD,COORDNUM;
    Vector[][][] POINT=new Vector[2][5000][200];
    Vector[][] POINT2=new Vector[2][10000];
    Vector[][] POINT3=new Vector[10][1000];
    Vector[][][] SPHERE=new Vector[2][1000][200];
    int DETAIL,CURVE_NUMBER,FLOW,TOTAL;
    int[][] COUNT=new int[2][1000];
    int[] TAG=new int[1000];
    ListenSquare GO,STOP,XY,TT,AT;
    Rotater ROT;
    Point JX;
    boolean drag;
    boolean XYPROJ;

     public BallCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(300,460,200,-200);
	 CONTROL=new ListenSquare(0,0,600,150);CONTROL.on=1;
	 SEND0=new ListenSquare(500,5,90,20);SEND0.on=1;
	 COORD=new Lever(5,45,0,3);
	 COORDNUM=new Lever(75,45,3,15);
	 XY=new ListenSquare(5,65,60,20);
	 TT=new ListenSquare(75,65,60,20);
	 AT=new ListenSquare(145,65,80,20);
	 GO=new ListenSquare(500,30,50,20);
	 STOP=new ListenSquare(550,30,40,20);
	 NUM[0]=new NumberEntry(430,5,50,20,"200");
	 NUM[1]=new NumberEntry(5,5,40,20,"8");
	 NUM[2]=new NumberEntry(135,5,40,20,"8");
	 NUM[3]=new NumberEntry(265,5,40,20,"8");
         setView();
	 DETAIL=30;
	 CURVE_NUMBER=10;
	 computeAll();
	 ROT=new Rotater(this.M);
	 drag=true;
	 XYPROJ=false;
     }

    public void setView() {
	 YAW=new EnhancedSlider(0,90,530,27,265,new Color(200,0,200),"yaw");
	 PITCH=new EnhancedSlider(0,120,530,27,265,new Color(200,0,200),"pitch");
	 SPEED=new Lever(350,60,5,20);
	 YAW.forceValue(.125);
	 PITCH.forceValue(.5);
	 YAW.POW.val=1;
	 PITCH.POW.val=1;
    }
    
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawBall(g);
      drawGeodesic(g);
      drawCutLocus(g);
      drawControls(g);
      drawFrame(g);
   }

    public void isspecialProjection() {
	XYPROJ=false;
	double x=PITCH.getValue();
	double y=YAW.getValue();
	if((x==.25)&&(y==.25)) XYPROJ=true;
    }

    public void drawBG(Graphics2D g) {
	g.setColor(Color.black);
	try{
   	   g.setColor(M.C.DISPLAY.M[0].C);
	}
	catch(Exception e) {}
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawFrame(Graphics2D g) {
	g.setColor(Color.white);
        g.drawRect(0,0,getWidth()-1,getHeight()-1); 
    }

    public void drawCutLocus(Graphics2D g) {
	Path2D.Double gp1=new Path2D.Double();
	Path2D.Double gp2=new Path2D.Double();
	if(M.C.DISPLAY.L[8].on==0) return;

	for(int i=0;i<999;++i) {
            double val=0.5*i/1000+.001;
	    double x=LevelCurve.limit(val);
	    double y=val/x;
	    double h=EllipticIntegrals.holonomy(Math.sqrt(val));
	    h=h*h;
	    x=x*Math.sqrt(h/val);
	    y=y*Math.sqrt(h/val);
	    Vector V1=new Vector(x,y,0);
	    Vector V2=new Vector(y,x,0);
	    double[] A1=view(V1);
	    double[] A2=view(V2);
	    if(i==0) gp1.moveTo(A1[0],A1[1]);
	    if(i!=0) gp1.lineTo(A1[0],A1[1]);
	    if(i==0) gp2.moveTo(A2[0],A2[1]);
	    if(i!=0) gp2.lineTo(A2[0],A2[1]);
	}
	gp1=transform(gp1);
	gp2=transform(gp2);
	g.setColor(M.C.DISPLAY.M[8].C);
	g.draw(gp1);
	g.draw(gp2);
    }



    public void drawControls(Graphics2D g) {
	CONTROL.render(g,new Color(20,30,50));
	YAW.render(g);
	PITCH.render(g);
	SPEED.render2(g,"speed",new Color(0,150,0));
	COORD.render(g,"coord",new Color(150,0,0));
	COORDNUM.render2(g,"# of curves",new Color(150,0,0));
	SEND0.render(g,new Color(80,140,255));
	XY.render(g,new Color(200,0,200));
	TT.render(g,new Color(200,0,200));
	AT.render(g,new Color(200,0,200));
	g.setColor(Color.white);
	g.drawString("XY proj",10,80);
	g.drawString("diag proj",80,80);
	g.drawString("anti diag proj",150,80);
	
	if(ROT.halt==true) {
	       GO.render(g,new Color(0,170,0));
	       g.drawString("animate",505,45);
	}
	
	if(ROT.halt==false) {
	    STOP.render(g,new Color(200,0,0));
	       g.drawString("stop",555,45);
	}

	for(int i=0;i<4;++i)  NUM[i].render(g,new Color(150,0,0),Color.white,Color.white);
	g.setColor(Color.white);  g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString("#loop",55,20);
	g.drawString("#long",185,20);
	g.drawString("#latt",315,20);
	g.drawString("detail",388,20);
	g.drawString("compute",510,20);
    }

    /**These are the projection routines*/


    public double[] view(Vector V) {
	Vector C=new Vector(0,0,0);
	Vector W=yaw(C,V);
	W=pitch(C,W);
	double[] A={W.x[0],W.x[2],W.x[1]};
	return A;
    }


    public Vector pitch(Vector C,Vector V0) {
  	  double t=PITCH.getValue();
	  t=2*Math.PI*t;
	  Vector V=Vector.minus(V0,C);
	  V=Vector.pitch(t,V);
	  V=Vector.plus(V,C);
	  return V;
    }

    public Vector yaw(Vector C,Vector V0) {
	double t=YAW.getValue();
	t=2*Math.PI*t;	
        Vector V=Vector.minus(V0,C);
	V=Vector.yaw(t,V);
	V=Vector.plus(V,C);
        return V;

    }

    /**end projection routines*/

    
   public void drawSegment(Graphics2D g,Vector V0,Vector V1,Color COL) {
	Path2D.Double gp=new Path2D.Double();
	double[] d0=view(V0);
	double[] d1=view(V1);
	gp.moveTo(d0[0],d0[1]);
	gp.lineTo(d1[0],d1[1]);
	gp=transform(gp);
	g.setColor(COL);
	g.draw(gp);
    }

    

    public void drawBall(Graphics2D g) {
	drawCurves(g);
	drawSingular(g);
	drawYinYang(g);
    }




    
    public void drawCurves(Graphics2D g) {
	int lim=1;
	if(M.C.SYMM.mode==1) lim=4;
	for(int r=0;r<lim;++r) {
	for(int j=0;j<CURVE_NUMBER;++j) {
	    if(M.C.DISPLAY.L[TAG[j]].on==1) {
		g.setColor(M.C.DISPLAY.M[TAG[j]].C);
	        Path2D.Double gp=toPath(r,j,POINT[1],COUNT[1][j]);
	        gp=transform(gp);
	        g.draw(gp);
	    }
	}
	}
    }



    

    public Path2D.Double toPath(int r,int j,Vector[][] V,int n) {
	Path2D.Double gp=new Path2D.Double();
       for(int i=0;i<n;++i) {
	  Vector W=new Vector(V[i][j]);
	  if(r==1) W.x[0]=-W.x[0];
	  if(r==2) W.x[1]=-W.x[1];
	  if(r==3) { 
             W.x[0]=-W.x[0];
	     W.x[1]=-W.x[1];
	  }
          double[] A=view(W);
          if(i==0) gp.moveTo(A[0],A[1]);
          if(i>0)  gp.lineTo(A[0],A[1]);
       }
       return gp;
    }


    /**This is the singular set on the sphere*/
    
    public void drawSingular(Graphics2D g) {
	try{
	    boolean test=false;
	    if(M.C.DISPLAY.L[4].on==1) test=true;
	    if(M.C.DISPLAY.L[5].on==1) test=true;
	    if(test==false) return;
	}
	catch(Exception e) {return;}
		    
	 Path2D.Double gp=new Path2D.Double();
	 for(int k=0;k<2;++k) {
	     Color COL=M.C.DISPLAY.M[4+k].C;
	     for(int i=0;i<COUNT[0][k];++i) {
	         Vector V0=POINT[0][i][k];
	         double[] A0=view(V0);
	         if(i==0) gp.moveTo(A0[0],A0[1]);
	         if(i>0)  gp.lineTo(A0[0],A0[1]);
	     }
	     if(M.C.DISPLAY.L[4+k].on==1) {
	        gp=transform(gp);
	        g.setColor(COL);
	        g.draw(gp);
	     }
	 }
    }


    public void drawYinYang(Graphics2D g) {
	try{
	   if(M.C.DISPLAY2.L[3].on==0) return;
	}
	catch(Exception e) {}
	 Color COL=M.C.DISPLAY2.M[3].C;
	 Path2D.Double gp=new Path2D.Double();
	 for(int j=2;j<4;++j) {
	   for(int i=0;i<COUNT[0][j];++i) {
	      Vector V0=POINT[0][i][j];
	      double[] A0=view(V0);
	      if(i==0) gp.moveTo(A0[0],A0[1]);
	      if(i>0)  gp.lineTo(A0[0],A0[1]);
	   }
	   gp=transform(gp);
	   g.setColor(COL);
	   g.draw(gp);
	 }
    }



    public void drawGeodesic(Graphics2D g) {
	Color[] COL={new Color(255,0,255), new Color(255,200,0)};
		     int[] on={0,0};
	try {
	  COL[0]=M.C.DISPLAY.M[6].C;
	  COL[1]=M.C.DISPLAY.M[7].C;
	  on[0]=M.C.DISPLAY.L[6].on;
	  on[1]=M.C.DISPLAY.L[7].on;
	}
	catch(Exception e) {}

	for(int k=0;k<2;++k) {
	    if(on[k]==1) {
	     g.setColor(COL[k]);
	     Path2D.Double gp=new Path2D.Double();
	     for(int j=0;j<POINT2[k].length;++j) {
	        Vector V=POINT2[k][j];
	        double[] A=view(V);
	        if(j==0) gp.moveTo(A[0],A[1]);
	        if(j!=0) gp.lineTo(A[0],A[1]);
	     }
	     gp=transform(gp);
	     g.draw(gp);
	    }
	}
    }
    
	


    public void computeAll() {
	CURVE_NUMBER=0;
	computeCurves();
	computeAnnularBoundary();
	computeYinYang();
	computeGeodesic();
    }

    public void computeCurves() {
	double step=.001;
	double length=1;
	try {
            step=M.C.getStepsize();
	    length=M.V.getRadius();
	}
	catch(Exception e) {}
	computeLoopLevels(step,length);
	computeLongitude(0,step,length);
	computeLongitude(1,step,length);
    }
    
    public void computeLoopLevels(double step,double length) {
	DETAIL=NUM[0].getInteger();
	int num=NUM[1].getInteger()+2;
	double[] A={0,1};
	try {
	    A=M.V.getLimits();
	}
	catch(Exception e) {}

	for(int j=0;j<num;++j) {
	    double t0=1.0*j/(num-1);
	    double t=(1-t0)*A[0]+t0*A[1];
	    int detail=DETAIL;
	    if(t<.5) detail=DETAIL/2;
	    if(t>.99) detail=5*detail;
  	    Vector[] LIST=LevelCurve.curveCheap(detail,t);

	    int count=0;
	    for(int i=0;i<=detail;++i) {
	        Vector TEMP=GeodesicMaker.geodesicEndpoint(step,length,LIST[i%detail]);
	        POINT[1][count][j]=new Vector(TEMP);
	        ++count;
	    }
	    COUNT[1][j]=count;
	    TAG[CURVE_NUMBER]=1;
	    ++CURVE_NUMBER;
	}
    }


    public void computeLongitude(int choice, double step,double length) {
	DETAIL=NUM[0].getInteger();
       	int num=NUM[2+choice].getInteger()+2;

	
	double[] LIM={0,1};
	try{LIM=M.V.getLimits();}
	catch(Exception e) {}

	for(int j=0;j<num;++j) {
	    double theta=.5*Math.PI*1.0*j/(num-1);
	    Vector[] LIST=null;
  	    if(choice==0) LIST=LevelCurve.curveLongitude(DETAIL,theta);
  	    if(choice==1) LIST=LevelCurve.curveLattitude(DETAIL,theta);

	    int count=0;
	    for(int i=0;i<DETAIL;++i) {
		double[] A=LIST[i].sphereToChart();
		double r=Math.sqrt(A[0]*A[0]+A[1]*A[1]);
		if((r>LIM[0])&&(r<LIM[1])) {
	          Vector TEMP=GeodesicMaker.geodesicEndpoint(step,length,LIST[i]);
	          POINT[1][count][CURVE_NUMBER]=new Vector(TEMP);
		  ++count;
		}
	    }
	    COUNT[1][CURVE_NUMBER]=count;
	    TAG[CURVE_NUMBER]=2+choice;
	    ++CURVE_NUMBER;
	}
    }





    
    

    public void computeAnnularBoundary() {
	double step=.001;
	double[] A={0,1};
	double rad=1;
	try{
	      step=M.C.getStepsize();
	      A=M.V.getLimits();
	      rad=M.V.getRadius();
	}
	catch(Exception e) {}
	
	for(int k=0;k<2;++k) {    
	   Vector[] LIST=LevelCurve.curveCheap(5*DETAIL,A[k]);
	   for(int i=0;i<5*DETAIL;++i) {
	      POINT[0][i][k]=GeodesicMaker.geodesicEndpoint(step,rad,LIST[i]);
	   }
	   COUNT[0][k]=5*DETAIL;
	}
    }


    public void computeYinYang() {
	double step=.001;
	double length=1;
	Vector[] LIST0=new Vector[0];
	Vector[] LIST1=new Vector[0];
	
	try{
	  step=M.C.getStepsize();
	  length=M.V.getRadius();
	  LIST0=M.V.yinCurve0();
	  LIST1=M.V.yinCurve1();
	}
	catch(Exception e) {return;}

	for(int i=0;i<LIST0.length;++i) {
	   POINT[0][i][2]=GeodesicMaker.geodesicEndpoint(step,length,LIST0[i]);
	   POINT[0][i][3]=GeodesicMaker.geodesicEndpoint(step,length,LIST1[i]);
	}
	COUNT[0][2]=LIST0.length;
	COUNT[0][3]=LIST1.length;
    }




    public double[] fitInBox(double s,double t) {
	double x0=0;
	double x1=1;
	double y0=0;
	double y1=1;
	try{
	   x0=M.V.BOX[0].x;
	   y0=M.V.BOX[0].y;
	   x1=M.V.BOX[1].x;
	   y1=M.V.BOX[1].y;
	}
	catch(Exception e) {}
	double ss=(1-s)*x0+s*x1;
	double tt=(1-t)*y0+t*y1;
	ss=ss/4;
	double[] A={ss,tt};
	return A;
    }


    
    public void computeGeodesic() {
	double step=.001;
	double length=1;
	Vector U=new Vector(.6,.8,0);
	try{
	  step=M.C.getStepsize();  
          length=M.V.getRadius();
	  U=new Vector(M.V.V);
	}
	catch(Exception e) {}

	POINT2[0]=GeodesicMaker.geodesic(step,length,U);
	U.x[2]=-U.x[2];
	POINT2[1]=GeodesicMaker.geodesic(step,length,U);
    }


    /**end computation of balls*/

    /**XY projection*/
    public void specialProjection(Point X) {
	if(XY.inside(X)==1) {
	    PITCH.forceValueSimple(.25);
	    YAW.forceValueSimple(.25);
	}
	if(TT.inside(X)==1) {
	    PITCH.forceValueSimple(1);
	    YAW.forceValueSimple(7.0/8);
	}
	if(AT.inside(X)==1) {
	    PITCH.forceValueSimple(1);
	    YAW.forceValueSimple(5.0/8);
	}
	syncViews();
	isspecialProjection();
    }


    /**animation*/
    public void doGo() {
	if(ROT.halt==false) return;
	ROT=new Rotater(this.M);
	new Thread(ROT).start();
    }
        
    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	for(int i=0;i<4;++i) NUM[i].activate(J.X);
	YAW.activate(J.X);
	PITCH.activate(J.X);
	drag=true;
    }
    
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void syncViews() {
       if(M.C.VIEW.L[1].on==1) {
		M.V.PITCH.forceValue(PITCH.getValue());
		M.V.YAW.forceValue(YAW.getValue());
	}
    }

    public void coordShortcut(Point X) {
	COORDNUM.process(X);
	int k=COORD.isUsed(X);
	if(k==-1) return;
	 for(int i=0;i<3;++i) {
	     NUM[i+1].S="0";
	     M.C.DISPLAY.L[i+1].on=0;
	 }
	int t=(int)(Math.pow(2,COORDNUM.val));
	Integer T=new Integer(t);
	NUM[k+1].S=T.toString();
	M.C.DISPLAY.L[k+1].on=1;
    }
    

    
    public void doMouseClick(int mode) {
	specialProjection(JX);
	if(CONTROL.inside(JX)==1) {
	   specialProjection(JX);
	   if(SEND0.inside(JX)==1) computeAll();
	   if(GO.inside(JX)==1) doGo();
	   if(STOP.inside(JX)==1) ROT.halt=true; 
           YAW.configure(JX);
	   PITCH.configure(JX);
           SPEED.process(JX);
	   syncViews();
	   coordShortcut(JX);
	   M.repaint();
	   return;
	}
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	if(mode==2) SOURCE=unTransform(JX);
	M.repaint();
    }


     public void mouseReleased(MouseEvent e) {
	 drag=false;	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(drag==true) {
	    YAW.configure(J.X,true);
	    PITCH.configure(J.X,true);
	    syncViews();
	}
	JX=J.X;
     }

     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	specialProjection(J.X);
	YAW.configure(J.X,true);
	PITCH.configure(J.X,true);
	M.repaint();
     }
  public void keyTyped(KeyEvent e) {

      char ch=e.getKeyChar();
      if(ch=='z') doMouseClick(1);
      if(ch=='x') doMouseClick(2);
      if(ch=='c') doMouseClick(3);      
      for(int i=0;i<4;++i) NUM[i].modify(e);
         M.repaint();
     }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }

}

