import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DrawCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;
    int MODE;


    int[] COUNT0=new int[10];  //number of raw data points
    int[] COUNT1=new int[10];  //number of output points
    
    double[] SMOOTH=new double[10];
    Complex[][] Z=new Complex[10][1000];
    EnhancedSlider SMOOTH0,POINTS;
    ListenSquare[] CHOICE=new ListenSquare[10];
    ListenSquare[] COLOR=new ListenSquare[10];
    ListenSquare[] RESET=new ListenSquare[10];
    boolean ALIVE;

     public DrawCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	setup();
	for(int i=0;i<10;++i) {
	    COUNT0[i]=0;
	    COUNT1[i]=64;
	    SMOOTH[i]=256;
	}
	SMOOTH0=new EnhancedSlider(5,5,530,27,529,new Color(50,50,255),"smoothness");
	POINTS=new EnhancedSlider(5,35,530,27,529,new Color(0,0,200),"points");
	SMOOTH0.POW.val=8;
	POINTS.POW.val=6;
	MODE=0;
	ALIVE=true;
     }


    public void setup() {
	for(int i=0;i<10;++i) {
            CHOICE[i]=new ListenSquare(5+20*i,70,17,17);	
            COLOR[i]=new ListenSquare(5+20*i,90,17,17);
            RESET[i]=new ListenSquare(5+20*i,110,17,17);
	    COLOR[i].C=Color.white;
	}	
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      render(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(150,0,0));
        g.fillRect(0,0,getWidth(),getHeight());
    }
    
    public void render(Graphics2D g) {
	
	for(int i=0;i<10;++i) {
	    Color C=Color.blue;
	    if(i==MODE) C=Color.yellow;
            CHOICE[i].render(g,C);
	    COLOR[i].render(g,COLOR[i].C);
	    RESET[i].render(g,Color.black);
	}  
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.setColor(Color.white);
	g.drawString("choice",220,83);
	g.drawString("color",220,103);
	g.drawString("reset",220,123);

	String[] S=new String[4];
	S[0]="This is a tool for drawing curves on the vector selection window.";
	S[1]="You can draw up to 10 curves.";
	S[2]="Use the sliders to control their smoothness and the number of points they contain.";
	S[3]="Use the row of buttons to select your curve, change its color, and reset it.";
	for(int i=0;i<4;++i) g.drawString(S[i],5,160+20*i);
	

	SMOOTH0.render(g);
	POINTS.render(g);
    }

    public int curveChoice(Point X) {
	for(int i=0;i<10;++i) {
	    if(CHOICE[i].inside(X)==1) return i;
	}
	return -1;
    }

    public int process(Point X,Color C) {
	for(int i=0;i<10;++i) {
	    if(CHOICE[i].inside(X)==1) MODE=i;
	    if(COLOR[i].inside(X)==1) COLOR[i].C=new Color(C.getRed(),C.getGreen(),C.getBlue());
	    if(RESET[i].inside(X)==1) COUNT0[i]=0;
	}
	return -1;
    }

    public void mousePressed(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	SMOOTH0.activate(J.X);
	POINTS.activate(J.X);
	COUNT1[MODE]=(int)(POINTS.getValue());
    }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	process(J.X,M.C.CS.C);
	M.repaint();
    }



     public void mouseDragged(MouseEvent e) {
	 MouseData J=MouseData.process(e);
	SMOOTH0.configure(J.X);
	POINTS.configure(J.X);
	COUNT1[MODE]=(int)(POINTS.getValue());
	M.repaint();
     }

     public void mouseReleased(MouseEvent e) {	
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
	 
     }
     public void mouseExited(MouseEvent e) {
     }  

     public void mouseMoved(MouseEvent e) {
     }

}

