import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(20,480,460);	

     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawGraysonCylinder(g);
      drawGeodesic(g);
   }


    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,0));
        g.fillRect(0,0,getWidth(),getHeight()); 
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(0,0);
	gp.lineTo(1,0);
	gp.lineTo(1,1);
	gp.lineTo(0,1);
	gp.closePath();
	gp=transform(gp);
	g.setColor(new Color(20,30,40));
	g.fill(gp);
    }

    public void drawFrame(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(0,0);
	gp.lineTo(1,0);
	gp.lineTo(1,1);
	gp.lineTo(0,1);
	gp.closePath();
	gp=transform(gp);
	g.setColor(new Color(0,0,255));
	g.draw(gp);
    }

    public void drawGraysonCylinder(Graphics2D g) {
	Color C=new Color(200,0,200);
	double a=getGraysonA();
	Path2D.Double gp=new Path2D.Double();
	gp=GraysonCylinder.main(a,true);
	gp=transform(gp);
	g.setColor(C);
	g.fill(gp);
	g.draw(gp);
    }


    public void drawGeodesic(Graphics2D g) {
	double step=.0001;
	double length=1;
	Vector U=new Vector(.6,.8,0);

	try{
	 step=M.C.getStepsize();
	 length=M.V.getRadius();
	 U=new Vector(M.V.V);
	}
	catch(Exception e) {}

	Path2D.Double gp=new Path2D.Double();
	gp=GeodesicMaker.elevationGeodesic(0,step,length,U,true,false);
	gp=transform(gp);
	g.setColor(Color.white);
	g.draw(gp);
    }



    public double getGraysonA() {
	Vector U=new Vector(.6,.8,0);
	U=new Vector(M.V.V);
	double a=Math.sqrt(U.x[0]*U.x[1]);
	return a;
    }
     
    
    public void mousePressed(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	M.repaint();
    }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	M.repaint();
    }
     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
     }




}

