import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class SmallCanvas extends ScaleCanvas implements KeyListener,MouseListener, MouseMotionListener {
    Manager M;
    Path2D.Double[] CURVE=new Path2D.Double[20];
    EnhancedSlider RADIUS;
    Point JX;
    boolean drag;
    ListenSquare CONTROL;
    ListenSquare CONTROL2;
    ControlPanelColor DISPLAY;

     public SmallCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 CONTROL=new ListenSquare(0,0,0,0);
	 CONTROL2=new ListenSquare(0,0,0,0);
      	 setScales(160,550,40,40);
	 RADIUS=new EnhancedSlider(0,00,680,27,100,new Color(200,0,200),"raw value");
	 setPanels();
     }



    public void setPanels() {

       Color[] C0={new Color(80,120,255),
                   Color.white,
                   Color.white,
                   Color.black,
                   Color.white};

	String[] DisplayString={"backg",
				 "axes",
                                "\u2202N and \u22020N",
                                "\u22020M",
                                "\u039B foliation",
                                "\u039B moving",
				"\u0394 interior",
				"\u0394 outline",
                                "display"};
	Color[] DisplayColor={new Color(255,255,255),
			      new Color(150,150,150),
                              new Color(255,255,0),
			      new Color(50,100,255),
                              new Color(155,155,255),
                              new Color(50,80,255),
			      new Color(255,100,100),
			      new Color(200,0,0)};

	int[] DisplayState={1,1,1,0,0,1,1,1};
        DISPLAY=new ControlPanelColor(C0,DisplayString,DisplayState,8,DisplayColor);

    }
    
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      
      CONTROL=new ListenSquare(0,0,this.getWidth(),28);CONTROL.on=1;
      CONTROL2=new ListenSquare(0,0,120,this.getHeight());CONTROL.on=1;
      drawBG(g);
      if(DISPLAY.L[2].on==1) drawCutLocus(g);
      if(DISPLAY.L[3].on==1) drawPreCut(g);
      drawTriangle(g);
      drawSmallFoliation(g);
      drawSmallCurve(g);
      drawControls(g);
   }
    
    public void drawControls(Graphics2D g) {
        CONTROL.render(g,Color.black);
        CONTROL2.render(g,Color.black);
	DISPLAY.render(g,0,28,120);
         RADIUS.render(g);
	 Double D=new Double(getRadius());
	 g.setColor(Color.white);
	 g.setFont(new Font("Helvetica",Font.PLAIN,14));
	 g.drawString("radius "+D.toString(),250,22);
    }

    public void drawBG(Graphics2D g) {
	g.setColor(DISPLAY.M[0].C);
        g.fillRect(0,0,getWidth(),getHeight());
	if(DISPLAY.L[1].on==0) return;
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-100,0);
	gp.lineTo(100,0);
	gp.moveTo(0,-100);
	gp.lineTo(0,100);
	gp=transform(gp);
	g.setColor(DISPLAY.M[1].C);
	g.draw(gp);
    }


    public void drawSmallCurve(Graphics2D g) {
	if(DISPLAY.L[5].on==0) return;
	Path2D. Double p=new Path2D.Double();
	if(CURVE[0]!=null) {
	  p=transform(CURVE[0]);
	  g.setColor(new Color(20,40,255));
	  g.draw(p);
	}
    }


    public void drawTriangle(Graphics2D g) {
	Path2D. Double p=new Path2D.Double();
	if(CURVE[1]!=null) {
	  p=transform(CURVE[1]);
	  g.setColor(DISPLAY.M[6].C);
	  if(DISPLAY.L[6].on==1) g.fill(p);
	  g.setColor(DISPLAY.M[7].C);
	  if(DISPLAY.L[7].on==1) g.draw(p);
	}
    }


    


    public void drawSmallFoliation(Graphics2D g) {
	if(DISPLAY.L[4].on==0) return;
	Path2D. Double p=new Path2D.Double();
	g.setColor(DISPLAY.M[4].C);
	for(int i=2;i<20;++i) {
	  p=transform(CURVE[i]);
	  g.draw(p);
	}
    }



    
    public void computeSmall() {
	for(int i=0;i<2;++i) {
	    CURVE[i]=new Path2D.Double();
	}
	    double step=M.C.STEP.getValue();
	    double L=getRadius();
       	    double d=EllipticIntegrals.periodInverse(L);
	    int count=0;
	    Vector TEST=new Vector();
	    Vector U=LevelCurve.sideVector(d);
	    Vector[] V=GeodesicMaker.geodesic(step,L,U);
	    
	    for(int i=V.length/2-1;i>=0;--i) {
		Vector Z1=new Vector(V[i]);
		Vector Z2=new Vector(V[V.length-1-i]);
		TEST=GroupStructure.leftTranslationInverse(Z1,Z2);
		double[] A={TEST.x[0],TEST.x[1]};
	        if(count==0) CURVE[0].moveTo(A[0],A[1]);
	        if(count!=0) CURVE[0].lineTo(A[0],A[1]);
                ++count;
	    }
            CURVE[1].moveTo(0,0);
            CURVE[1].lineTo(TEST.x[0],TEST.x[1]);
            CURVE[1].lineTo(TEST.x[0],0);
            CURVE[1].closePath();
    }



    public void computeSmallFoliation() {
	for(int i=2;i<20;++i) {
	    CURVE[i]=new Path2D.Double();

	    double step=M.C.STEP.getValue();
	    double L=Math.PI*Math.sqrt(2)+.2*i-.39999;
       	    double d=EllipticIntegrals.periodInverse(L);
	    int count=0;
	    Vector TEST=new Vector();
	    Vector U=LevelCurve.sideVector(d);
	    Vector[] V=GeodesicMaker.geodesic(step,L,U);
	    
	    for(int j=V.length/2-1;j>=0;--j) {
		Vector Z1=new Vector(V[j]);
		Vector Z2=new Vector(V[V.length-1-j]);
		TEST=GroupStructure.leftTranslationInverse(Z1,Z2);
		double[] A={TEST.x[0],TEST.x[1]};
	        if(count==0) CURVE[i].moveTo(A[0],A[1]);
	        if(count!=0) CURVE[i].lineTo(A[0],A[1]);
                ++count;
	    }
	}
    }

    

    public double getRadius() {
        double L=RADIUS.getValue();
	double r=Math.PI*Math.sqrt(2)+L;
	return r;
    }	



    /**This draws the set $\partial_0 M$ from the paper.*/
    
    
    public void drawPreCut(Graphics2D g) {
	Path2D.Double gp1=new Path2D.Double();
	Path2D.Double gp2=new Path2D.Double();
	
	for(int i=0;i<999;++i) {
	    double val2=0.5*i/1000+.001;
	    double x=LevelCurve.limit(val2);
	    double y=val2/x;
	    double H=EllipticIntegrals.period(val2);
	    
	    x=x*H;
	    y=y*H;
	    if(i==0) gp1.moveTo(x,y);
	    if(i!=0) gp1.lineTo(x,y);
	    if(i==0) gp2.moveTo(y,x);
	    if(i!=0) gp2.lineTo(y,x);
	}
	gp1=transform(gp1);
	gp2=transform(gp2);
	g.setColor(DISPLAY.M[3].C);
	g.draw(gp1);
	g.draw(gp2);
	
    }

    /**This draws the set $\partial_0 N$ from the paper*/

    public void drawCutLocus(Graphics2D g) {
	Path2D.Double gp0=new Path2D.Double();
	Path2D.Double gp1=new Path2D.Double();
	Path2D.Double gp2=new Path2D.Double();
	for(int i=0;i<999;++i) {
	    double val2=0.5*i/1000+.001;
	    double x=LevelCurve.limit(val2);
	    double y=val2/x;
	    double hol=EllipticIntegrals.holonomy(Math.sqrt(val2));
	    double H=hol/Math.sqrt(val2);
	    x=x*H;
	    y=y*H;
	    if(i==0) gp1.moveTo(x,y);
	    if(i!=0) gp1.lineTo(x,y);
	    if(i==0) gp2.moveTo(y,x);
	    if(i!=0) gp2.lineTo(y,x);
	}

	double a=Math.PI;
	gp0.moveTo(0,99);
	gp0.lineTo(a,a);
	gp0.lineTo(99,0);
	gp0.closePath();
	gp0=transform(gp0);
	
	gp1=transform(gp1);
	gp2=transform(gp2);
	g.setColor(DISPLAY.M[2].C);
       	g.fill(gp0);
       	g.fill(gp1);
	g.fill(gp2);
	g.setColor(Color.black);
	g.draw(gp1);
	g.draw(gp2);
    }


    public void doDisplay(Point X) {
      int test=DISPLAY.process(JX,M.C.CS.C);
      if(test==4) computeSmallFoliation();
      if(test==20) DocControls.triangleTheorem(M.D);
    }



    
    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	RADIUS.activate(J.X);
	drag=true;
    }

    
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) {

	int test=CONTROL.inside(JX)+CONTROL2.inside(JX);
	
	if(test!=0) {
	     RADIUS.configure(JX);
	     doDisplay(JX);
	     computeSmall();
	     repaint();
	     return;
	}
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	repaint();
    }


     public void mouseReleased(MouseEvent e) {
	 drag=false;	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
     }

     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	RADIUS.configure(J.X);
	computeSmall();
	M.repaint();
     }
  public void keyTyped(KeyEvent e) {

      char ch=e.getKeyChar();
         M.repaint(); 
         if(ch=='z') doMouseClick(1);
         if(ch=='c') doMouseClick(3);
     }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }

}

