import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class BallCanvas extends ScaleCanvas implements KeyListener,MouseListener, MouseMotionListener {
    Manager M;
    ListenSquare CONTROL,SEND;
    NumberEntry[] NUM=new NumberEntry[3];
    EnhancedSlider PITCH,YAW,SPEED;
    Vector[][][] POINT=new Vector[2][500][100];
    Vector[] POINT2=new Vector[10000];
    Vector[][][] SPHERE=new Vector[2][500][100];
    int DETAIL,LONG,LATT,TOTAL;
    ListenSquare GO,STOP;
    Rotater ROT;
    Point JX;
    boolean drag;

     public BallCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(300,350,100);
	 CONTROL=new ListenSquare(0,0,600,150);CONTROL.on=1;
	 SEND=new ListenSquare(470,5,80,20);SEND.on=1;
	 GO=new ListenSquare(340,30,60,20);
	 STOP=new ListenSquare(400,30,50,20);
	 NUM[1]=new NumberEntry(5,5,50,20,"16");
	 NUM[2]=new NumberEntry(5,35,50,20,"32");
	 NUM[0]=new NumberEntry(205,5,50,20,"50");
	 YAW=new EnhancedSlider(0,60,530,27,265,Color.blue,"yaw");
	 PITCH=new EnhancedSlider(0,90,530,27,265,new Color(0,200,0),"pitch");
	 SPEED=new EnhancedSlider(0,120,530,27,265,new Color(200,0,200),"animation speed");
	 DETAIL=30;
	 LONG=10;
	 LATT=10;
	 computeBall();
	 ROT=new Rotater(this.M);
	 drag=true;
     }
    
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawAxes(g);
      drawBall(0,g);
      drawBall(1,g);
      drawGeodesic(g);
      drawControls(g);
      drawFrame(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(Color.black);
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawFrame(Graphics2D g) {
	g.setColor(Color.white);
        g.drawRect(0,0,getWidth()-1,getHeight()-1); 
    }



    public void drawControls(Graphics2D g) {
	CONTROL.render(g,new Color(0,0,100));
	YAW.render(g);
	PITCH.render(g);
	SPEED.render(g);
	SEND.render(g,new Color(0,200,0));
	
	if(ROT.halt==true) {
	       GO.render(g,new Color(0,170,0));
	       g.drawString("animate",345,45);
	}
	
	if(ROT.halt==false) {
	    STOP.render(g,new Color(200,0,0));
	       g.drawString("stop",410,45);
	}

	for(int i=0;i<3;++i)  NUM[i].render(g,new Color(0,0,50),Color.white,Color.white);
	g.setColor(Color.white);  g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString("lattitude",70,20);
	g.drawString("longitude",70,50);
	g.drawString("detail",270,20);
	g.drawString("recompute",480,20);
    }

    /**These are the transformations we use for rendering*/

    public void drawAxes(Graphics2D g) {

	Color COLZ=new Color(0,0,200);
	Color COLH=new Color(0,200,200);
	int onZ=0;
	int onH=0;

	try{
	    onZ=M.C.DISPLAY.L[3].on;
	    onH=M.C.DISPLAY.L[4].on;
	    COLZ=M.C.DISPLAY.M[3].C;
	    COLH=M.C.DISPLAY.M[4].C;
	}
	catch(Exception e) {}
	    
	Vector V0=new Vector(0,0,-100);
	Vector V1=new Vector(0,0,+100);
	if(onZ==1) drawAxes(g,V0,V1,COLZ);
	V0=new Vector(-100,-100,0);
	V1=new Vector(+100,+100,0);
	if(onH==1) drawAxes(g,V0,V1,COLH);
	V0=new Vector(+100,-100,0);
	V1=new Vector(-100,+100,0);
	if(onH==1) drawAxes(g,V0,V1,COLH);
    }

    
	public void drawAxes(Graphics2D g,Vector V0,Vector V1,Color COL) {
	Path2D.Double gp=new Path2D.Double();
	double[] d0=view(V0);
	double[] d1=view(V1);
	gp.moveTo(d0[0],d0[1]);
	gp.lineTo(d1[0],d1[1]);
	gp=transform(gp);
	g.setColor(COL);
	g.draw(gp);
    }


    public double[] view(Vector V) {
	Vector W=pitch(V);
	W=yaw(W);
	double[] A={W.x[0],W.x[2],W.x[1]};
	return A;
    }

    

    public Vector pitch(Vector V) {
  	  double t=PITCH.getValue();
	  t=2*Math.PI*t;
	  return Vector.pitch(t,V);
    }

    public Vector yaw(Vector V) {
	double t=YAW.getValue();
	t=2*Math.PI*t;
	return Vector.yaw(t,V);
    }

    public void drawBall(int choice,Graphics2D g) {
	Color COL=new Color(255,0,255);
	int on=1;
	try {
	  COL=M.C.DISPLAY.M[1+choice].C;
	  on=M.C.DISPLAY.L[1+choice].on;
	}
	catch(Exception e) {}
	if(on==0) return;
	g.setColor(COL);

	int LIM=0;
	if(choice==0) LIM=LATT;
	if(choice==1) LIM=LONG;

	    for(int j=0;j<LIM;++j) {
		Path2D.Double gp=new Path2D.Double();
	        for(int i=0;i<=DETAIL;++i) {
		    Vector V0=POINT[choice][i][j];
		    double[] A0=view(V0);
		    if(i==0) gp.moveTo(A0[0],A0[1]);
		    if(i>0)  gp.lineTo(A0[0],A0[1]);
		}
		gp=transform(gp);
		g.draw(gp);
	    }
    }


    public void drawGeodesic(Graphics2D g) {
	Color COL=new Color(255,0,255);
	int on=1;
	try {
	  COL=M.C.DISPLAY.M[0].C;
	  on=M.C.DISPLAY.L[0].on;
	}
	catch(Exception e) {}
	if(on==0) return;

	g.setColor(COL);
	Path2D.Double gp=new Path2D.Double();
	
	for(int j=0;j<POINT2.length;++j) {
	     Vector V=POINT2[j];
	     double[] A=view(V);
	     if(j==0) gp.moveTo(A[0],A[1]);
	     if(j!=0) gp.lineTo(A[0],A[1]);
	}
	gp=transform(gp);
	g.draw(gp);
    }


    /**These routines compute the ball*/

    public void computeBall() {
	int geom=0;
	try{geom=M.C.GEOM.mode;}
	catch(Exception e) {}
	computeBall(geom,0);
	computeBall(geom,1);
	computeGeodesic(geom);
    }
    
    public void computeBall(int geom,int mode) {
	double step=.001;
	double length=1;
	try{
	  step=M.C.getStepsize();
	  length=M.V.RADIUS.getValue();
	}
	catch(Exception e) {}
	DETAIL=NUM[0].getInteger();
	LATT=NUM[1].getInteger();
	LONG=NUM[2].getInteger();
	int LIM=LATT;
	if(mode==1) LIM=LONG;
	
	    for(int j=0;j<LIM;++j) {
		double s=1.0*j/(LIM-1);
	        for(int i=0;i<=DETAIL;++i) {
		   double t=1.0*i/DETAIL;
		   Vector U=Vector.spherePoint(t,s);
		   if(mode==1) U=Vector.spherePoint(s,t);
		   SPHERE[mode][i][j]=new Vector(U);
		   POINT[mode][i][j]=GeodesicMaker.geodesicEndpoint(geom,step,length,U);
		}
	    }
    }

    
    public void computeGeodesic(int geom) {
	double step=.001;
	double length=1;
	Vector U=new Vector(.6,.8,0);
	try{
	  step=M.C.getStepsize();  
          length=M.V.RADIUS.getValue();
	  U=new Vector(M.V.V);
	}
	catch(Exception e) {}
	POINT2=GeodesicMaker.geodesic(geom,step,length,U);
    }


    /**end computation of balls*/

    /**animation*/
    public void doGo() {
	if(ROT.halt==false) return;
	ROT=new Rotater(this.M);
	new Thread(ROT).start();
    }
        
    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	for(int i=0;i<3;++i) NUM[i].activate(J.X);
	YAW.activate(J.X);
	PITCH.activate(J.X);
	SPEED.activate(J.X);
	drag=true;
    }
    
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
	if(CONTROL.inside(JX)==1) {
	   if(SEND.inside(JX)==1) computeBall();
	   if(GO.inside(JX)==1) doGo();
	   if(STOP.inside(JX)==1) ROT.halt=true; 
           YAW.configure(JX);
	   PITCH.configure(JX);
	   SPEED.configure(JX);
	   M.repaint();
	   return;
	}
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	M.repaint();
    }


     public void mouseReleased(MouseEvent e) {
	 drag=false;	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(drag==true) {
	    YAW.configure(J.X,true);
	    PITCH.configure(J.X,true);
	    SPEED.configure(J.X,true);
	}
	JX=J.X;
     }

     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	YAW.configure(J.X,true);
	PITCH.configure(J.X,true);
	SPEED.configure(J.X,true);
	M.repaint();
     }
  public void keyTyped(KeyEvent e) {

      char ch=e.getKeyChar();
      if(ch=='z') doMouseClick(1);
      if(ch=='x') doMouseClick(2);
      if(ch=='c') doMouseClick(3);      
      for(int i=0;i<3;++i) NUM[i].modify(e);
         M.repaint();
     }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }

}

