import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener {
    Manager M;
    SelectColor CS;
    SelectInteger S;
    EnhancedSlider STEP;
    ControlPanel ACTION,PROJ,GEOM;
    ControlPanelColor DISPLAY;
    PopupManager POP;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 CS=new SelectColor(M,0,249,499,50);
	 setSliders();
	 setSliders();
	 setPanels();
     }

    public void setPanels() {

       Color[] C0={new Color(80,120,255),
                   Color.white,
                   Color.white,
                   Color.black,
                   Color.white};


       String[] ActionString={"none",
                              "set Z=0",
                              "set X=Y",
			      "polar view",
                              "set length=critical",
                              "set length=period","coord locks"};
       int[] ActionState={1,0,0,0,0,0};
        ACTION=new ControlPanel(C0,ActionString,ActionState,6);
	ACTION.mode=0;


	String[] GeomString={"SOL","NIL","EUC","geometry"};
	int[] GeomState={1,0,0};
        GEOM=new ControlPanel(C0,GeomString,GeomState,3);



	String[] DisplayString={"geodesic",
                                "sphere lattitude",
                                "sphere longitude",
                                "Z-axis","horontal axes",
				"vector select bg",
				"select sphere",
                                "select grid",
                                "display"};
	Color[] DisplayColor={new Color(255,0,255),
                              Color.white,
                              Color.yellow,
                              new Color(0,0,200),
                              new Color(0,200,200),
                              new Color(0,0,0),
                              new Color(20,30,40),
			      new Color(50,60,70)};
	int[] DisplayState={0,1,0,0,0,1,1,1};
        DISPLAY=new ControlPanelColor(C0,DisplayString,DisplayState,8,DisplayColor);
    }

    
    public void setSliders() {
	STEP=new EnhancedSlider(0,0,430,30,430,new Color(0,0,200),"integration stepsize");
	STEP.POW.val=-10;
    }


    public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
      drawData(g);
   }


    public void drawData(Graphics2D g) {
	if(GEOM.mode!=0) return;
	double step=getStepsize();
	double length=M.V.RADIUS.getValue();
	double[] data=GeodesicMaker.periodData(0,step,M.V.V);
	Double[] Data=new Double[4];
	for(int i=0;i<4;++i) Data[i]=new Double(data[i]);
	String[] S={"period","x holonomy","y holonomy","holonomy length"};
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(Color.white);
	int lim=0;
	if(data[0]>20) {
	    lim=1;
            g.drawString("period not computed",250,175);
	}
	for(int i=lim;i<4;++i)
	g.drawString(S[i]+" "+Data[i].toString(),250,175+20*i);
    }

    

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,80,80));
      g.fillRect(0,0,getWidth(),getHeight()); 
    }
    
    public void drawControls(Graphics2D g) {
	DISPLAY.render(g,0,35,125);
	ACTION.render(g,130,35,125);
	GEOM.render2(g,260,35,80);
        STEP.render(g);
        CS.render(g);
	POP.render(g);
    }

    
    public double getStepsize() {
	return STEP.getValue();
    }

  
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	DISPLAY.process(J.X,CS.C);
	STEP.configure(J.X);
	GEOM.switchMode(J.X);
	ACTION.switchMode(J.X);
	POP.process(J.X);
	CS.process(e);
	M.repaint();


    }

    
    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	STEP.activate(J.X);
	repaint();
    }
    
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {

	MouseData J=MouseData.process(e);
	STEP.configure(J.X);

	CS.process(e);
	M.repaint();
     } 

}

