import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocInstructions {

    public DocInstructions() {}


    public static void setup(DocumentCanvas D) {
    
	String S="Sol Geometry Explorer\n";
	S=S+"by Rich Schwartz\n";
	S=S+"program started: October 2019\n";
	S=S+"Last updated:  13 October 2019\n";


	S=S+"\n\nPURPOSE:\n\n";
	S=S+"This program computes geodesics and smallish geodesic spheres in SOL using integration of the Grayson structure field.   The basic idea was known to Matt Grayson in the 1980s, when he wrote his Princeton PhD thesis.  Matei Coiculescu and I have been investigating this way of computing geodesics.  Eventually this program is going to do a lot more.";

	    S=S+"\n\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"First, here is some information about this text window. This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. There is more text than what is now visible.  You can resize this window and  also change the font size.";

	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the picture windows, buttoms 1 and 3 zoom in and out of the picture and button 2 generally selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c to simulate the 3 buttons when you are operating any of the windows where you might want to rescale the picture.";

	    S=S+"\n\nSome of the windows in this program are popups. You push the button on the popup control panel to summon the window.  If you open the same window more than once, the thing malfunctions. In this case just kill all copies of the window including the origin and summon it again.";

	    S=S+"\n\nThis program has a number of sliders and enhanced sliders. The enhanced sliders have arrow keys and boxes to their right. You change the value of a slider (or enhanced slider) by dragging the mouse along the bar.  For the advanced slider you can use the arrow keys to multiply the value by a selected power of 2.  The squares to the far right reset the slider bar.  Just try it to see how it works.";

	    S=S+"The Vector Selection Window and the SOL Sphere window are resizeable.";


	    S=S+"\n\nMAIN FEATURES";

	    S=S+"\n\nAside from this text window, the program has 4 other windows.\n\n"; 

	    S=S+"Control panel";
	    S=S+"\n\nVector Selection Window";
	    S=S+"\n\nSOL Sphere Window";



	S=S+"\n\nCONTROL PANEL:\n\n";
	S=S+"You select things in the control panel by clicking in the buttons. Here is what you can do on the control panel;";

	S=S+"\n\nChange the integration stepsize.  This is the stepsize which goes into the computation of SOL geodesics.  The smaller the number, the more accurate the computation.   The tradeoff is that very small stepsizes lead to long calculations.";
	S=S+"\n\nChoose to display and recolor a number of objects shown in the other windows.";

	S=S+"\n\nForce various choices to be made when you use the vector selection window.";


	S=S+"These various features will be explained as we go along.";

	    S=S+"\n\nVECTOR SELECTION WINDOW";

	    S=S+"\n\nThis window shows a unit sphere. By dragging the mouse over the sphere you can select a unit vector. You can use the pitch and yaw sliders to change the viewpoint of the sphere. You can use the radius slider to select/change the length of the geodesic you want to draw.  You can also use the vector actions control panel to force various properties of the selected geodesic.  The window shows the coordinates of the selected geodesic, so you can try it out and see how it works.";

	    S=S+"\n\nSOL SPHERE WINDOW:";

	    S=S+"\n\nThis window plots the image of a sphere of some radius under the exponential map. You use the vector selection window to select the radius.  When the radius is small, the image we are talking about coincides with a sphere.  When the radius is large, the SOL sphere of the selected radius is distinct from the image of the sphere under the exponential map. Unfortunately, we draw the latter.  The cutoff is sqrt 2 times Pi.";

	    S=S+"\n\nYou can use the pitch and yaw sliders to change the view of the plotted object. You can use the number fields to change the number of lines of longitude and lattitude plotted. You can recolor various things using the control panel. Again, just fool around with it and see how it works.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void keyControls(DocumentCanvas D) {
	String S="Keyboard commands:  You can use the keyboard for various commands.\n\nGENERAL:  In general, the keys z,x,c emulate the 3 buttons on a 3 button mouse.\n\n";
	S=S+"POLYGON WINDOW: \n\n (a) add vertex to polygon \n(d) delete vertex\n\n";
	S=S+"PHASE SPACE WINDOW:\n\n (1) plot orbit with color selector color\n(2) plot orbit with a random color\n(3) display symbolic dynamics\n(4)clear plot.\n\n";

	S=S+"PHASE PLOT WINDOW\n\n(1) select first vertex of the zoom box\n(2) select second vertex of the zoom box\n(3)zoom in\n(4)return to initial view";

	try{
        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
	}
	catch(Exception e) {}
    }




}

