import java.awt.event.*;
import java.awt.*;
import java.math.*;
import java.awt.geom.*;


public class GraysonCylinder {

    /**GRAYSON'S CYLINDER*/

    /**Here is the image of Grayson's cylinder in the (w,z) plane.  
       Here w=(x-y)/sqrt(2).*/

    public static double getZ(double a,double w) {
	double b=1/(2*a*a)-w*w;
	double z=.5*acosh(b);
	return z;
    }

    /**here t0 runs from 0 to 1*/
    
    public static double parametrizeW(double a,double t0) {
	double t=2*t0-1;
	double w=Math.sqrt(1-2*a*a)/(a*Math.sqrt(2));
	return t*w;
    }

    public static Path2D.Double main(double a,boolean fit) {
	double[][] t=raw(a);
	if(fit==true) t=GeodesicAnalyzer.fitInSquare(t);
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<t.length;++i) {
	    if(i==0) gp.moveTo(t[i][0],t[i][1]);
	    if(i!=0) gp.lineTo(t[i][0],t[i][1]);
	}
	gp.closePath();
	return gp;
    }

    
    public static double[][] raw(double a) {
	
	double[][] t=new double[2000][2];
	
	for(int i=0;i<1000;++i) {
	    double t0=1.0*i/1000;
	    double w=parametrizeW(a,t0);
	    double z=getZ(a,w);
	    t[i][0]=w;
	    t[i][1]=z;
	}

	for(int i=0;i<1000;++i) {
	    double t0=1-1.0*i/1000;
	    double w=parametrizeW(a,t0);
	    double z=getZ(a,w);
	    t[i+1000][0]=w;
	    t[i+1000][1]=-z;
	}
	return t;
    }


    /**inverse hyperbolic cosine (cosh^{-1})*/
    
    public static double acosh(double x) {
	double y=x+Math.sqrt(x*x-1);
	return Math.log(y);
    }
    
}
