import java.awt.event.*;
import java.awt.*;
import java.math.*;
import java.awt.geom.*;


public class GroupStructure {

    /**These routines give you the structure for nil or sol*/

    public static Vector leftTranslation(int choice,Vector V,Vector W) {
	if(choice==0) return leftTranslationSOL(V,W);
	if(choice==1) return leftTranslationNIL(V,W);
	if(choice==2) return leftTranslationEUC(V,W);
	return null;
    }

    public static Vector structureField(int choice,Vector V) {
	if(choice==0) return structureFieldSOL(V);
	if(choice==1) return structureFieldNIL(V);
	if(choice==2) return structureFieldEUC(V);
	return null;
    }





    /**SOL*/

    public static Vector leftTranslationSOL(Vector V,Vector W) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double a=W.x[0];
	double b=W.x[1];
	double c=W.x[2];
	double aa=a*Math.exp(+z)+x;
	double bb=b*Math.exp(-z)+y;
	double cc=c+z;
	Vector Z=new Vector(aa,bb,cc);
	return Z;
    }

    public static Vector structureFieldSOL(Vector V) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double a=+x*z;
	double b=-y*z;
	double c=+y*y-x*x;
	Vector W=new Vector(a,b,c);
	return W;
    }



    /**NIL*/

    public static Vector leftTranslationNIL(Vector V,Vector W) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double a=W.x[0];
	double b=W.x[1];
	double c=W.x[2];
	double aa=a+x;
	double bb=b+y;
	double cc=c+z+x*b;
	Vector Z=new Vector(aa,bb,cc);
	return Z;
    }

    public static Vector structureFieldNIL(Vector V) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double a=-y*z;
	double b=+x*z;
	double c=+0;
	Vector W=new Vector(a,b,c);
	return W;
    }

    /**NIL*/

    public static Vector leftTranslationEUC(Vector V,Vector W) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double a=W.x[0];
	double b=W.x[1];
	double c=W.x[2];
	double aa=a+x;
	double bb=b+y;
	double cc=c+z;
	Vector Z=new Vector(aa,bb,cc);
	return Z;
    }

    public static Vector structureFieldEUC(Vector V) {
	Vector W=new Vector(0,0,0);
	return W;
    }


}
